Index: branches/powerups/src/lib/gui/gtk_gui/gui_exec.cc
===================================================================
--- branches/powerups/src/lib/gui/gtk_gui/gui_exec.cc	(revision 5871)
+++ branches/powerups/src/lib/gui/gtk_gui/gui_exec.cc	(revision 5955)
@@ -27,5 +27,5 @@
 
 #include "resource_manager.h"
-#include "ini_parser.h"
+#include "parser/ini_parser/ini_parser.h"
 
 #include <string.h>
@@ -254,5 +254,5 @@
 
 /**
- *  Reads in Configuration Data.
+ * @brief Reads in Configuration Data.
  * @param widget from which Widget on should be saved.
 */
@@ -265,5 +265,5 @@
     return;
 
-  iniParser.getFirstSection();
+  iniParser.firstSection();
   Widget* groupWidget = widget;
   const char* groupName;
@@ -272,17 +272,20 @@
   while (groupName = iniParser.getCurrentSection())
   {
+    printf("GROUP:::%s\n", groupName);
     if((groupWidget = locateGroup(widget, groupName, 1))==NULL)
-    {
-      PRINTF(2)("!!There is no group called %s in this GUI.\n First best Widget will get the Infos assigned.\n Config-File will be updated in next Save\n", groupName);
-      groupWidget = widget;
-      continue;
-    }
+      {
+	PRINTF(2)("!!There is no group called %s in this GUI.\n First best Widget will get the Infos assigned.\n Config-File will be updated in next Save\n", groupName);
+	groupWidget = widget;
+	continue;
+      }
     else
-      PRINT(0)("Group %s located.\n", static_cast<Packer*>(groupWidget)->groupName);
-
-    iniParser.getFirstVar();
-    while(iniParser.getCurrentName())
-    {
-      varInfo.variableName = iniParser.getCurrentName();
+      PRINT(4)("Group %s located.\n", static_cast<Packer*>(groupWidget)->groupName);
+
+    const char* entryName;
+    iniParser.firstVar();
+    while(entryName = iniParser.getCurrentName())
+    {
+      PRINTF(4)("ENTRY:::%s = %s\n", entryName, iniParser.getCurrentValue());
+      varInfo.variableName = entryName;
       varInfo.variableValue = iniParser.getCurrentValue();
       groupWidget->walkThrough(this->readFileText, &varInfo, 0);
@@ -303,9 +306,13 @@
 {
   VarInfo* info =(VarInfo*)varInfo;
+  if (info == NULL || info->variableName == NULL)
+    return;
+
   if(widget->title && !strcmp(widget->title, info->variableName))
     {
       PRINT(5)("Located Option %s.\n", widget->title);
       if(widget->optionType > GUI_NOTHING)
-        static_cast<Option*>(widget)->load(info->variableValue);
+	if (info->variableValue != NULL)
+	  static_cast<Option*>(widget)->load(info->variableValue);
     }
 }
@@ -323,15 +330,16 @@
 {
   Widget* tmp;
+  if (widget  == NULL || groupName == NULL)
+    return NULL;
 
   if(widget->optionType < GUI_NOTHING)
     {
-      if(static_cast<Packer*>(widget)->getGroupName() &&
+      if(static_cast<Packer*>(widget)->getGroupName() != NULL &&
          !strcmp(groupName, static_cast<Packer*>(widget)->getGroupName()))
-        {
-          return widget;
-        }
+	return widget;
       else
         {
-          if((tmp = locateGroup(static_cast<Packer*>(widget)->down, groupName, depth+1)) != NULL)
+          if((tmp = locateGroup(static_cast<Packer*>(widget)->down,
+				groupName, depth+1)) != NULL)
             return tmp;
         }
Index: branches/powerups/src/lib/gui/gtk_gui/gui_keys.cc
===================================================================
--- branches/powerups/src/lib/gui/gtk_gui/gui_keys.cc	(revision 5871)
+++ branches/powerups/src/lib/gui/gtk_gui/gui_keys.cc	(revision 5955)
@@ -119,5 +119,5 @@
         pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_LEFT, "LEFT"));
         pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_RIGHT, "RIGHT"));
-        pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_FIRE, "MOUSE_LEFT"));
+        pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_FIRE, "BUTTON_LEFT"));
         pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_NEXT_WEAPON, "m"));
         pKeysBox->fill(addKey(CONFIG_NAME_PLAYER_PREV_WEAPON, "n"));
Index: branches/powerups/src/lib/lang/base_object.cc
===================================================================
--- branches/powerups/src/lib/lang/base_object.cc	(revision 5871)
+++ branches/powerups/src/lib/lang/base_object.cc	(revision 5955)
@@ -112,6 +112,6 @@
   else if (classID & CL_MASK_SUBSUPER_CLASS)
   {
-    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_ID) == (this->classID & CL_MASK_SUBSUPER_CLASS_ID)) &&
-        this->classID & classID & CL_MASK_SUBSUPER_CLASS_ID2))
+    if (likely(((this->classID & CL_MASK_SUBSUPER_CLASS_IDA) == (this->classID & CL_MASK_SUBSUPER_CLASS_IDA)) &&
+        this->classID & classID & CL_MASK_SUBSUPER_CLASS_IDB))
       return true;
   }
Index: branches/powerups/src/lib/lang/class_list.cc
===================================================================
--- branches/powerups/src/lib/lang/class_list.cc	(revision 5871)
+++ branches/powerups/src/lib/lang/class_list.cc	(revision 5955)
@@ -133,5 +133,5 @@
  * @return the List accessed by classID, or NULL if not found
  */
-std::list<BaseObject*>* ClassList::getList(ClassID classID)
+const std::list<BaseObject*>* ClassList::getList(ClassID classID)
 {
   ClassList* fl;
@@ -156,5 +156,5 @@
  * @return the List accessed by classID, or NULL if not found
  */
-std::list<BaseObject*>* ClassList::getList(const char* className)
+const std::list<BaseObject*>* ClassList::getList(const char* className)
 {
   ClassList* fl;
Index: branches/powerups/src/lib/lang/class_list.h
===================================================================
--- branches/powerups/src/lib/lang/class_list.h	(revision 5871)
+++ branches/powerups/src/lib/lang/class_list.h	(revision 5955)
@@ -40,9 +40,11 @@
     static void                           removeFromClassList(BaseObject* objectPointer);
 
-    static std::list<BaseObject*>*        getList(ClassID classID = CL_NULL);// { return (ClassList* fl = ClassList::getClassList(classID) != NULL)? &(fl->objectList) : NULL; };
-    static std::list<BaseObject*>*        getList(const char* className); // { return (ClassList* fl = ClassList::getClassList(className) != NULL)? &(fl->objectList) : NULL;  };
+    static const std::list<BaseObject*>*  getList(ClassID classID = CL_NULL);// { return (ClassList* fl = ClassList::getClassList(classID) != NULL)? &(fl->objectList) : NULL; };
+    static const std::list<BaseObject*>*  getList(const char* className); // { return (ClassList* fl = ClassList::getClassList(className) != NULL)? &(fl->objectList) : NULL;  };
     static const std::list<const char*>*  getClassNames();
     static BaseObject*                    getObject(const char* name, ClassID classID = CL_NULL);
     static bool                           exists(const BaseObject* object, ClassID classID = CL_NULL);
+
+    void                                  sendBack(std::list<BaseObject*>::const_iterator it);
 
     static void                           whatIs(const BaseObject* object);
@@ -51,5 +53,5 @@
     static long                           StringToID(const char* className);
     static void                           debug(unsigned int debugLevel = 0, long classID = CL_NULL);
-    static void                           debugS(const char* className = 0x0, unsigned int debugLevel = 0);
+    static void                           debugS(const char* className = NULL, unsigned int debugLevel = 0);
 
     inline bool                           operator==(ClassID classID) { return (this->classID == classID); };
Index: branches/powerups/src/lib/network/network_manager.cc
===================================================================
--- branches/powerups/src/lib/network/network_manager.cc	(revision 5871)
+++ branches/powerups/src/lib/network/network_manager.cc	(revision 5955)
@@ -161,5 +161,5 @@
   if (this->netStreamList != NULL || (this->netStreamList = ClassList::getList(CL_NETWORK_STREAM)) != NULL)
   {
-    std::list<BaseObject*>::iterator stream;
+    std::list<BaseObject*>::const_iterator stream;
     for (stream = this->netStreamList->begin(); stream != this->netStreamList->end(); ++stream)
       static_cast<NetworkStream*>(*stream)->processData();
Index: branches/powerups/src/lib/network/network_manager.h
===================================================================
--- branches/powerups/src/lib/network/network_manager.h	(revision 5871)
+++ branches/powerups/src/lib/network/network_manager.h	(revision 5955)
@@ -41,6 +41,6 @@
 
 private:
-  std::list<BaseObject*>*    netStreamList;            // list with refs to all network streams
-  std::list<BaseObject*>*    syncList;                 // list of synchronizeables
+  const std::list<BaseObject*>*    netStreamList;            // list with refs to all network streams
+  const std::list<BaseObject*>*    syncList;                 // list of synchronizeables
 
 };
Index: branches/powerups/src/lib/parser/Makefile.am
===================================================================
--- branches/powerups/src/lib/parser/Makefile.am	(revision 5955)
+++ branches/powerups/src/lib/parser/Makefile.am	(revision 5955)
@@ -0,0 +1,5 @@
+SUBDIRS = \
+          tinyxml \
+	  ini_parser
+
+
Index: branches/powerups/src/lib/parser/ini_parser/Makefile.am
===================================================================
--- branches/powerups/src/lib/parser/ini_parser/Makefile.am	(revision 5955)
+++ branches/powerups/src/lib/parser/ini_parser/Makefile.am	(revision 5955)
@@ -0,0 +1,10 @@
+
+noinst_LIBRARIES = libIniParser.a
+
+libIniParser_a_SOURCES = ini_parser.cc
+
+libIniParser_a_CPPFLAGS = "-DNO_SHELL"
+
+noinst_HEADERS = ini_parser.h
+
+
